#include "serial0.h"
#include <stdio.h>		// For Used Function printf 
#include "math.h"
#include "LPC214x.H"  	// LPC2148 MPU Register
#include "adis16350.h"
#include "timer.h"
#include "spi_mmc.h"
#include "type.h"
#include "delay.h"
#include "kalman.h"
#include "IMU_calib.h"
//extern data for display
float	angleWx,angleWy,angleWz;
float	q_biasWx,q_biasWy;
float   rate_Wx,rate_Wy;

void display_6_axises(void)	  //for send I character
{
	
	unsigned short ADIS16350_rbuff[7];
	signed short ADIS16350_data[7];
	unsigned short st;
	char status;
	SPI_read16_ADIS16350(ADIS16350_rbuff);
	status = map_14bit_to_16bit_format(ADIS16350_rbuff,ADIS16350_data,7);
	if(status)
	{
		printf("\nIMU invalid data\n\r" );
		printf("@%04x,%04x,%04x,%04x,%04x,%04x,!",ADIS16350_rbuff[3],ADIS16350_rbuff[4],ADIS16350_rbuff[5],ADIS16350_rbuff[0],ADIS16350_rbuff[1],ADIS16350_rbuff[2]);

		st=check_error_status();
		printf("%04x\n\r",st);

		 display_error_status();
		
	}
  	else
	{
		printf("@%d,%d,%d,%d,%d,%d,!",ADIS16350_data[3],ADIS16350_data[4],ADIS16350_data[5],ADIS16350_data[0],ADIS16350_data[1],ADIS16350_data[2]);
		putchar(13);
		putchar(10);
	}
}

void display_angle(char option)	  //for send D and R character
{
//static unsigned int count_timer;
//static float tempX,tempY;
//printf("% u",count_timer++);
	unsigned short ADIS16350_rbuff[7];
	signed short ADIS16350_data[7];
	char status;
	float angleX,angleY;
	float scale;
	if(option=='R')
	{
	  scale=1;
	}
	else
	{
	  scale=(float)180/3.14159265;
	}
	SPI_read16_ADIS16350(ADIS16350_rbuff);
	status = map_14bit_to_16bit_format(ADIS16350_rbuff,ADIS16350_data,7);
	if(status)
	{
		printf("\nIMU invalid data\n\r" );
	}
  	else
	{
		
		angleX=atan2(ADIS16350_data[4],ADIS16350_data[5])*scale;
		angleY=atan2(ADIS16350_data[3],ADIS16350_data[5])*scale;
		printf("@%04.4f,%04.4f,%d,%d,%d,%d,!",angleX,angleY,ADIS16350_data[5],ADIS16350_data[0],ADIS16350_data[1],ADIS16350_data[2]);
		putchar(13);
		putchar(10);
	}
}
