/**
 * @file sllist_test.c
 * This is a test file for the sllist module.
 *
 * Copyright (c) 2008, Steve Denson
 * See end of file for terms of use.
 */
#include <stdio.h>
#include <stdlib.h>
#include <vga_text.h>

#include "sllist.h"

int gmheap[256]; // malloc heap

/**
 * main test for singly linked list sllist module
 * - starts vga
 * - sets up heap for malloc
 * - creates and populates a list
 * - prints list
 * - destroys list
 */
void main(void)
{
    sllist_t* list;
    sllist_node_t* ptr;

    vgaText_start(16);
    _NewHeap(gmheap, gmheap+sizeof(gmheap)-1);

    list = sllist_create();

    sllist_add(list,"hello world\n");
    sllist_add(list,"how's your day?\n");
    sllist_add(list,"still spinning?\n");

    ptr = list->head;
    while(ptr) {
        printf(ptr->value);
        ptr = ptr->next;
    }
    sllist_destroy(list);
}

/*
+------------------------------------------------------------------------------------------------------------------------------+
                                                   TERMS OF USE: MIT License                                                                                                              
+------------------------------------------------------------------------------------------------------------------------------
Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation     
files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,    
modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software
is furnished to do so, subject to the following conditions:                                                                   
                                                                                                                              
The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
                                                                                                                              
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE          
WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR         
COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,   
ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                         
+------------------------------------------------------------------------------------------------------------------------------+
*/