@echo off
@echo "Catalina C. Synth.c program"
@echo "Ported from Synth.spin by Juan Carlos Orozco ACELAB.com"

@REM Define program to compile:
set PROGRAM=Synth

if NOT "%CATALINA_DEFINE%" == "" goto define_error

if NOT "%1"=="" goto start
@echo.
@echo ERROR: no PLATFORM specified !
@echo.
@echo usage: build_all PLATFORM [OPTIONS]
@echo.
@echo    where  PLATFORM is HYDRA, HYBRID, RAMBLADE, TRIBLADEPROP, DRACBLADE,
@echo                       DEMO or CUSTOM
@echo    and    OPTIONS are other Catalina options (e.g. CPU_1, HIRES_TV, NTSC)
@echo.
@echo Note: The spinc.exe program must have been built - see build_spinc.bat
@echo.
goto done

:start
set CATALINA_DEFINE=NO_HMI %1 %2 %3 %4 %5 %6 %7 %8 %9
del /q /f *.binary

@echo.
@echo    ========
@echo    Building
@echo    ========
@echo.

@REM homespun %PROGRAM%.spin -b
@REM spinc %PROGRAM%.binary > %PROGRAM%_array.h
@REM Compile for production:
@REM If debugging comment next line:
catalina -lc -I. %PROGRAM%.c ctra.e ctrb.e frqa.e frqb.e phsa.e phsb.e

@echo.
@REM If debugging uncomment next line:
@REM catalina -lc -g3 -I. %PROGRAM%.c ctra.e ctrb.e frqa.e frqb.e phsa.e phsb.e

@REM Choose payload or propellent:
@REM payload %PROGRAM%.binary
propellent .\%PROGRAM%.binary

@REM If debugging uncomment next line:
@REM blackcat -D %PROGRAM%.dbg
@echo.


call unset CATALINA_DEFINE
goto done

:define_error
@echo.
@echo ERROR: Environment variable CATALINA_DEFINE is set (to %CATALINA_DEFINE%)
@echo.
@echo You must undefine this environment variable before using this 
@echo batch file, and instead specify the target on the command line.
@echo.

:done

