	.area text(rom,rel)
	.dbfile ..\..\..\..\..\..\DOCUME~1\Steve\MYDOCU~1\_Propeller_OBEX_\Graphics\Graphics.c
	.area data(ram,rel)
	.dbfile ..\..\..\..\..\..\DOCUME~1\Steve\MYDOCU~1\_Propeller_OBEX_\Graphics\Graphics.c
	.align	4
_Graph_colors::
	.long 0
	.long 1431655765
	.long 2863311530
	.long 4294967295
	.dbfile C:\DOCUME~1\Steve\MYDOCU~1\_Propeller_OBEX_\Graphics\Graphics.c
	.dbsym e Graph_colors _Graph_colors A[16:4]i
_Graph_pixels:
	.byte 0,0,0,0
	.byte 0,0,2,5
	.byte 10,10,26,26
	.byte 52,58,'t,'t
	.dbsym s Graph_pixels _Graph_pixels A[16:16]c
	.area text(rom,rel)
	.dbfile C:\DOCUME~1\Steve\MYDOCU~1\_Propeller_OBEX_\Graphics\Graphics.c
	.dbfunc e Graph_start _Graph_start fI
;            cog -> R4
;             wt -> R5
_Graph_start::
	@FENTER	
	.long R4,R5,R15,0	
	.dbline -1
	.dbline 75
; /**
;  * @file Graphics.c
;  * Graphics driver ported from Chip Gracy's Graphics.spin
;  * Users should comment out unused functions to save code space if necessary.
;  * Copyright (c) 2009, Steve Denson
;  * See end of file for MIT license terms.
;  */
; #include <stdio.h>
; #include <string.h>
; #include <propeller.h>
; #include "Graphics.h"
; 
; /**
; ''
; '' Theory of Operation:
; ''
; '' A cog is launched with code contained in Graphics_Array[] which
; '' processes commands sent by the Graph_* API wrapper functions.
; ''
; '' Points, lines, arcs, sprites, text, and polygons are rasterized into
; '' a specified stretch of memory which serves as a generic bitmap buffer.
; ''
; '' The bitmap can be displayed by the TV or VGA driver.
; '' To date, the C library version has been tested on TV only.
; ''
; '' See GraphicsTest.c for usage example.
; ''
;  */ 
; 
; /**
;  * Graphics_Array is the PASM Graphics engine code.
;  */ 
; extern long Graphics_Array[];
; extern short Graphics_Font[];
; 
; /**
;  * Graphics interface control structure
;  */
; static GraphCmd_ST gGraph;
; 
; static gr_uint32_t pa[GRAPH_MAX_ARGS]; // set command parameter array
; 
; /**
;  * Color codes
;  */
; gr_uint32_t Graph_colors[] =
; {
;   0x00000000,
;   0x55555555,
;   0xAAAAAAAA,
;   0xFFFFFFFF
; };
; 
; /**
;  * Round pixel recipes
;  */
; static char Graph_pixels[] =
; {
;     0x00, 0x00, 0x00, 0x00,         //0,1,2,3
;     0x00, 0x00, 0x02, 0x05,         //4,5,6,7
;     0x0A, 0x0A, 0x1A, 0x1A,         //8,9,A,B
;     0x34, 0x3a, 0x74, 0x74          //C,D,E,F
; };
; 
; /*
;  * Vector font in separate GraphicsFont.c file
;  */
; 
; 
; /**
;  * start graphics driver
;  * see header for API description.
;  */
; int  Graph_start(void)
; {
	.dbline 78
;     // spin uses fontptr := font. C has no such luxury
;     // to achieve the same result, we pass font in setup
;     int wt=2000000,cog;
	@FLDCNST	
	.long 2000000	
	mov R5,TEMP0	
	.dbline 79
;     Graph_stop();
	@FCALL	
	.long _Graph_stop	
	.dbline 80
;     cog = cognew_native((void*)Graphics_Array, (gr_uint32_t*)&gGraph.command)+1;
	mov R0,#8	
	@FLDCNST	
	.long _Graphics_Array	
	mov R1,TEMP0	
	@FLDCNST	
	.long _gGraph+4	
	mov R2,TEMP0	
	@FCALL	
	.long _coginit_native	
	mov R4,R0	
	add R4,#1	
	.dbline 81
;     gGraph.cog = cog;
	mov R15,R4	
	@FSTOREL	
	.long _gGraph	
	.long R15	
L3:
	.dbline 82
;     WAIT(wt);
	.dbline 82
	mov     TEMP0,R5
	.dbline 82
	add     TEMP0,cnt
	.dbline 82
	waitcnt TEMP0,R5 WZ WC NR
	.dbline 82
L4:
	.dbline 82
	.dbline 83
;     return cog;
	mov R0,R4	
	.dbline -2
L1:
	@FPOP	
	.long R15,R5,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r cog 4 I
	.dbsym r wt 5 I
	.dbend
	.dbfunc e Graph_stop _Graph_stop fV
	.dbstruct 0 132 GraphCmd_struct
	.dbfield 0 cog i
	.dbfield 4 command i
	.dbfield 8 pixel_width i
	.dbfield 12 bitmap_ptr pi
	.dbfield 16 bitmap_len i
	.dbfield 20 bases A[64:32]s
	.dbfield 84 slices A[32:8]i
	.dbfield 116 text_xs i
	.dbfield 120 text_ys i
	.dbfield 124 text_sp i
	.dbfield 128 text_just i
	.dbend
;             gp -> R0
;            cog -> R1
_Graph_stop::
	@FENTER	
	.long R15,0	
	.dbline -1
	.dbline 91
; }
; 
; /**
;  * stop graphics driver
;  * see header for API description.
;  */
; void Graph_stop(void)
; {
	.dbline 92
;     GraphCmd_ST* gp = &gGraph;
	@FLDCNST	
	.long _gGraph	
	mov R0,TEMP0	
	.dbline 93
;     gr_uint32_t cog = gp->cog-1;
	rdlong R1,TEMP0	
	sub R1,#1	
	.dbline 94
;     if(gp->cog > 0)
	rdlong R15,R0	WZ
IF_E	add PC,#4	;Jump to L7
L9:
	.dbline 95
;         COGSTOP(cog);
	.dbline 95
	COGSTOP R1
	.dbline 95
L10:
	.dbline 95
L7:
	.dbline 96
;     gp->cog = 0;
	mov R15,#0	
	wrlong R15,R0	
	.dbline -2
L6:
	@FPOP	
	.long R15,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r gp 0 pS[GraphCmd_struct]
	.dbsym r cog 1 i
	.dbend
	.dbfunc e Graph_setup _Graph_setup fV
;             gp -> R4
;              n -> R9
;       base_ptr -> HRSP+0
;       y_origin -> R7
;       x_origin -> R8
;        y_tiles -> R5
;        x_tiles -> R6
_Graph_setup::
	@FENTER	
	.long R4,R5,R6,R7,R8,R9,R13,R14,R15,0	
	mov R6,R0	
	mov R5,R1	
	mov R8,R2	
	mov R7,R3	
	.dbline -1
	.dbline 104
; }
; 
; /**
;  * set bitmap parameters
;  * see header for API description.
;  */
; void Graph_setup(gr_uint32_t x_tiles, gr_uint32_t y_tiles, gr_uint32_t x_origin, gr_uint32_t y_origin, gr_uint32_t base_ptr)
; {
	.dbline 105
;     GraphCmd_ST* gp = &gGraph;
	@FLDCNST	
	.long _gGraph	
	mov R4,TEMP0	
	.dbline 106
;     int n = 0;
	.dbline 108
; 
;     sendCommand(GraphCmd_loop, 0);
	mov R0,#15	
	mov R1,#0	
	@FCALL	
	.long _sendCommand	
	.dbline 110
; 
;     for(n = 0; n < x_tiles && n < 32; n++)
	mov R9,#0	
	add PC,#84	;Jump to L16
L13:
	.dbline 111
;         gp->bases[n] = base_ptr + ((n * y_tiles) << 6);
	mov R0,#2	
	mov R1,R9	
	@FMUL32	
	mov R15,R0	
	mov R0,R9	
	mov R1,R5	
	@FMUL32	
	mov R14,R0	
	shl R14,#6	
	mov TEMP0,HRSP	
	add TEMP0,#0	
	rdlong TEMP0,TEMP0	
	mov R13,TEMP0	
	add R13,R14	
	mov R14,R13	
	mov R13,R4	
	add R13,#20	
	mov R15,R15	
	add R15,R13	
	wrword R14,R15	
L14:
	.dbline 110
	add R9,#1	
L16:
	.dbline 110
	mov R15,R9	
	cmp R15,R6	WC
IF_AE	add PC,#8	;Jump to L17
	cmps R9,#32	WC
IF_B	sub PC,#104	;Jump to L13
L17:
	.dbline 113
; 
;     y_tiles <<= 4;
	shl R5,#4	
	.dbline 114
;     y_origin = y_tiles - y_origin - 1;
	mov R15,R5	
	sub R15,R7	
	mov R7,R15	
	sub R7,#1	
	.dbline 116
; 
;     pa[0] = x_tiles;
	@FSTOREL	
	.long _pa	
	.long R6	
	.dbline 117
;     pa[1] = y_tiles;
	@FSTOREL	
	.long _pa+4	
	.long R5	
	.dbline 118
;     pa[2] = x_origin;
	@FSTOREL	
	.long _pa+8	
	.long R8	
	.dbline 119
;     pa[3] = y_origin;
	@FSTOREL	
	.long _pa+12	
	.long R7	
	.dbline 120
;     pa[4] = (gr_uint32_t)gp->bases; // driver ignores arg4
	mov R15,R4	
	add R15,#20	
	@FSTOREL	
	.long _pa+16	
	.long R15	
	.dbline 121
;     pa[5] = (gr_uint32_t)gp->bases;
	mov R15,R4	
	add R15,#20	
	@FSTOREL	
	.long _pa+20	
	.long R15	
	.dbline 122
;     pa[6] = (gr_uint32_t)gp->slices;
	mov R15,R4	
	add R15,#84	
	@FSTOREL	
	.long _pa+24	
	.long R15	
	.dbline 123
;     pa[7] = (gr_uint32_t)Graphics_Font;
	@FLDCNST	
	.long _Graphics_Font	
	mov R15,TEMP0	
	@FSTOREL	
	.long _pa+28	
	.long R15	
	.dbline 124
;     sendCommand(GraphCmd_setup, pa);
	mov R0,#1	
	@FLDCNST	
	.long _pa	
	mov R1,TEMP0	
	@FCALL	
	.long _sendCommand	
	.dbline 126
; 
;     gp->bitmap_ptr = (gr_uint32_t*)base_ptr;
	mov TEMP0,HRSP	
	add TEMP0,#0	
	rdlong TEMP0,TEMP0	
	mov R15,TEMP0	
	mov R14,R4	
	add R14,#12	
	wrlong R15,R14	
	.dbline 127
;     gp->bitmap_len = x_tiles * y_tiles;
	mov R0,R6	
	mov R1,R5	
	@FMUL32	
	mov R15,R0	
	mov R14,R4	
	add R14,#16	
	wrlong R15,R14	
	.dbline -2
L12:
	@FPOP	
	.long R15,R14,R13,R9,R8,R7,R6,R5,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r gp 4 pS[GraphCmd_struct]
	.dbsym r n 9 I
	.dbsym l base_ptr 0 i
	.dbsym r y_origin 7 i
	.dbsym r x_origin 8 i
	.dbsym r y_tiles 5 i
	.dbsym r x_tiles 6 i
	.dbend
	.dbfunc e Graph_clear _Graph_clear fV
_Graph_clear::
	@FENTER	
	.long R15,0	
	.dbline -1
	.dbline 136
;     //printf("\r\nBP Longs 0x%x Base 0x%x\n", gp->bitmap_longs, gp->bitmap_base);
; }
; 
; /**
;  * clear bitmap
;  * see header for API description.
;  */
; void Graph_clear(void)
; {
	.dbline 137
;     sendCommand(GraphCmd_loop, 0);
	mov R0,#15	
	mov R1,#0	
	@FCALL	
	.long _sendCommand	
	.dbline 138
;     memset(gGraph.bitmap_ptr, 0, gGraph.bitmap_len<<2);
	@FLOADL	
	.long _gGraph+12	
	.long R0	
	mov R1,#0	
	@FLOADL	
	.long _gGraph+16	
	.long R15	
	mov R2,R15	
	shl R2,#2	
	@FCALL	
	.long _memset	
	.dbline -2
L25:
	@FPOP	
	.long R15,0	
	@FRET
	.dbline 0 ; func end
	.dbend
	.dbfunc e Graph_copy _Graph_copy fV
;       dest_ptr -> R4
_Graph_copy::
	@FENTER	
	.long R4,R15,0	
	mov R4,R0	
	.dbline -1
	.dbline 146
; }
; 
; /**
;  * copy bitmap - use for double-buffered display
;  * see header for API description.
;  */
; void Graph_copy(gr_uint32_t dest_ptr)
; {
	.dbline 147
;     sendCommand(GraphCmd_loop, 0);
	mov R0,#15	
	mov R1,#0	
	@FCALL	
	.long _sendCommand	
	.dbline 148
;     memcpy((void*)dest_ptr, (void*)gGraph.bitmap_ptr, gGraph.bitmap_len<<2);
	mov R0,R4	
	@FLOADL	
	.long _gGraph+12	
	.long R1	
	@FLOADL	
	.long _gGraph+16	
	.long R15	
	mov R2,R15	
	shl R2,#2	
	@FCALL	
	.long _memcpy	
	.dbline -2
L28:
	@FPOP	
	.long R15,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r dest_ptr 4 i
	.dbend
	.dbfunc e Graph_color _Graph_color fV
;              c -> R4
_Graph_color::
	@FENTER	
	.long R4,R14,R15,0	
	mov R4,R0	
	.dbline -1
	.dbline 156
; }
; 
; /**
;  * set pixel color to two bit pattern
;  * see header for API description.
;  */
; void Graph_color(gr_uint32_t c)
; {
	.dbline 157
;     sendCommand(GraphCmd_color, (gr_uint32_t*)&Graph_colors[c & 3]);
	mov R15,R4	
	and R15,#3	
	mov R0,#4	
	mov R1,R15	
	@FMUL32	
	mov R15,R0	
	mov R0,#2	
	@FLDCNST	
	.long _Graph_colors	
	mov R14,TEMP0	
	mov R1,R15	
	add R1,R14	
	@FCALL	
	.long _sendCommand	
	.dbline -2
L31:
	@FPOP	
	.long R15,R14,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r c 4 i
	.dbend
	.dbfunc e Graph_width _Graph_width fV
;         passes -> R8
;              r -> R7
;             pw -> R6
;              n -> R5
;              w -> R4
_Graph_width::
	@FENTER	
	.long R4,R5,R6,R7,R8,R13,R14,R15,0	
	mov R4,R0	
	.dbline -1
	.dbline 165
; }
; 
; /**
;  * set pixel width - actual width is w[3..0]+1
;  * see header for API description.
;  */
; void Graph_width(gr_uint32_t w)
; {
	.dbline 168
;     int  passes, r, n, pw;
; 
;     r = ~w & 0x10;
	neg R15,R4	
	sub R15,#1	
	and R15,#16	
	mov R7,R15	
	.dbline 169
;     w &= 0xf;
	and R4,#15	
	.dbline 170
;     gGraph.pixel_width = w;
	@FSTOREL	
	.long _gGraph+8	
	.long R4	
	.dbline 171
;     passes = (w >> 1) + 1;
	mov R15,R4	
	shr R15,#1	
	add R15,#1	
	mov R8,R15	
	.dbline 173
; 
;     memset(pa, 0, GRAPH_MAX_ARGS<<2);
	@FLDCNST	
	.long _pa	
	mov R0,TEMP0	
	mov R1,#0	
	mov R2,#36	
	@FCALL	
	.long _memset	
	.dbline 174
;     pa[0] = w;
	@FSTOREL	
	.long _pa	
	.long R4	
	.dbline 175
;     pa[1] = passes;
	mov R15,R8	
	@FSTOREL	
	.long _pa+4	
	.long R15	
	.dbline 177
; 
;     sendCommand(GraphCmd_width, pa);
	mov R0,#3	
	@FLDCNST	
	.long _pa	
	mov R1,TEMP0	
	@FCALL	
	.long _sendCommand	
	.dbline 179
; 
;     pw = w ^ 0xf;
	mov R15,R4	
	xor R15,#15	
	mov R6,R15	
	.dbline 180
;     for(n = 0; n <= w >> 1; n++) {
	mov R5,#0	
	add PC,#164	;Jump to L38
L35:
	.dbline 180
	.dbline 181
;         gGraph.slices[n] = (gr_uint32_t)(0xffffffff >> (pw << 1)) << (pw & 0xE);
	mov R0,#4	
	mov R1,R5	
	@FMUL32	
	mov R15,R0	
	mov R14,R6	
	shl R14,#1	
	@FLDCNST	
	.long 0xffffffff	
	mov R13,TEMP0	
	shr R13,R14	
	mov R14,R6	
	and R14,#14	
	shl R13,R14	
	@FLDCNST	
	.long _gGraph+84	
	mov R14,TEMP0	
	mov R15,R15	
	add R15,R14	
	wrlong R13,R15	
	.dbline 182
;         if(r && (Graph_pixels[w] & (1 << n)))
	cmp R7,#0	WZ
IF_E	add PC,#48	;Jump to L40
	mov R15,#1	
	shl R15,R5	
	@FLDCNST	
	.long _Graph_pixels	
	mov R14,TEMP0	
	mov R13,R4	
	add R13,R14	
	rdbyte R14,R13	
	and R14,MASKFF	
	test R14,R15	WZ
IF_E	add PC,#4	;Jump to L40
	.dbline 183
;             pw += 2;
	add R6,#2	
L40:
	.dbline 184
;         if(r && n == passes - 2)
	cmp R7,#0	WZ
IF_E	add PC,#20	;Jump to L42
	mov R15,R8	
	sub R15,#2	
	cmp R5,R15	WZ
IF_NE	add PC,#4	;Jump to L42
	.dbline 185
;             pw += 2;
	add R6,#2	
L42:
	.dbline 186
;     }
L36:
	.dbline 180
	add R5,#1	
L38:
	.dbline 180
	mov R15,R4	
	shr R15,#1	
	mov R14,R5	
	cmp R14,R15	WZ WC
IF_BE	sub PC,#184	;Jump to L35
	.dbline -2
L32:
	@FPOP	
	.long R15,R14,R13,R8,R7,R6,R5,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r passes 8 I
	.dbsym r r 7 I
	.dbsym r pw 6 I
	.dbsym r n 5 I
	.dbsym r w 4 i
	.dbend
	.dbfunc e Graph_colorwidth _Graph_colorwidth fV
;              w -> R4
;              c -> R5
_Graph_colorwidth::
	@FENTER	
	.long R4,R5,0	
	mov R5,R0	
	mov R4,R1	
	.dbline -1
	.dbline 194
; }
; 
; /**
;  * set pixel color and width
;  * see header for API description.
;  */
; void Graph_colorwidth(gr_uint32_t c, gr_uint32_t w)
; {
	.dbline 195
;     Graph_color(c);
	mov R0,R5	
	@FCALL	
	.long _Graph_color	
	.dbline 196
;     Graph_width(w);
	mov R0,R4	
	@FCALL	
	.long _Graph_width	
	.dbline -2
L44:
	@FPOP	
	.long R5,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r w 4 i
	.dbsym r c 5 i
	.dbend
	.dbfunc e Graph_plot _Graph_plot fV
;              y -> R4
;              x -> R5
_Graph_plot::
	@FENTER	
	.long R4,R5,0	
	mov R5,R0	
	mov R4,R1	
	.dbline -1
	.dbline 204
; }
; 
; /**
;  * plot a pixel at point x,y
;  * see header for API description.
;  */
; void Graph_plot(gr_uint32_t x, gr_uint32_t y)
; {
	.dbline 205
;     pa[0] = x;
	@FSTOREL	
	.long _pa	
	.long R5	
	.dbline 206
;     pa[1] = y;
	@FSTOREL	
	.long _pa+4	
	.long R4	
	.dbline 207
;     sendCommand(GraphCmd_plot, pa);
	mov R0,#4	
	@FLDCNST	
	.long _pa	
	mov R1,TEMP0	
	@FCALL	
	.long _sendCommand	
	.dbline -2
L45:
	@FPOP	
	.long R5,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r y 4 i
	.dbsym r x 5 i
	.dbend
	.dbfunc e Graph_line _Graph_line fV
;              y -> R4
;              x -> R5
_Graph_line::
	@FENTER	
	.long R4,R5,0	
	mov R5,R0	
	mov R4,R1	
	.dbline -1
	.dbline 215
; }
; 
; /**
;  * draw a line to point x,y (from previous x,y?)
;  * see header for API description.
;  */
; void Graph_line(gr_uint32_t x, gr_uint32_t y)
; {
	.dbline 216
;     pa[0] = x;
	@FSTOREL	
	.long _pa	
	.long R5	
	.dbline 217
;     pa[1] = y;
	@FSTOREL	
	.long _pa+4	
	.long R4	
	.dbline 218
;     sendCommand(GraphCmd_line, pa);
	mov R0,#5	
	@FLDCNST	
	.long _pa	
	mov R1,TEMP0	
	@FCALL	
	.long _sendCommand	
	.dbline -2
L47:
	@FPOP	
	.long R5,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r y 4 i
	.dbsym r x 5 i
	.dbend
	.dbfunc e Graph_arc _Graph_arc fV
;        arcmode -> HRSP+12
;          steps -> HRSP+8
;      anglestep -> HRSP+4
;          angle -> HRSP+0
;             yr -> R4
;             xr -> R5
;              y -> R6
;              x -> R7
_Graph_arc::
	@FENTER	
	.long R4,R5,R6,R7,R15,0	
	mov R7,R0	
	mov R6,R1	
	mov R5,R2	
	mov R4,R3	
	.dbline -1
	.dbline 226
; }
; 
; /**
;  * draw an arc
;  * see header for API description.
;  */
; void Graph_arc(gr_uint32_t x, gr_uint32_t y, gr_uint32_t xr, gr_uint32_t yr, int angle, int anglestep, int steps, int arcmode)
; {
	.dbline 227
;     pa[0] = x;
	@FSTOREL	
	.long _pa	
	.long R7	
	.dbline 228
;     pa[1] = y;
	@FSTOREL	
	.long _pa+4	
	.long R6	
	.dbline 229
;     pa[2] = xr;
	@FSTOREL	
	.long _pa+8	
	.long R5	
	.dbline 230
;     pa[3] = yr;
	@FSTOREL	
	.long _pa+12	
	.long R4	
	.dbline 231
;     pa[4] = angle;
	mov TEMP0,HRSP	
	add TEMP0,#0	
	rdlong TEMP0,TEMP0	
	mov R15,TEMP0	
	@FSTOREL	
	.long _pa+16	
	.long R15	
	.dbline 232
;     pa[5] = anglestep;
	mov TEMP0,HRSP	
	add TEMP0,#4	
	rdlong TEMP0,TEMP0	
	mov R15,TEMP0	
	@FSTOREL	
	.long _pa+20	
	.long R15	
	.dbline 233
;     pa[6] = steps;
	mov TEMP0,HRSP	
	add TEMP0,#8	
	rdlong TEMP0,TEMP0	
	mov R15,TEMP0	
	@FSTOREL	
	.long _pa+24	
	.long R15	
	.dbline 234
;     pa[7] = arcmode;
	mov TEMP0,HRSP	
	add TEMP0,#12	
	rdlong TEMP0,TEMP0	
	mov R15,TEMP0	
	@FSTOREL	
	.long _pa+28	
	.long R15	
	.dbline 235
;     sendCommand(GraphCmd_arc, pa);
	mov R0,#6	
	@FLDCNST	
	.long _pa	
	mov R1,TEMP0	
	@FCALL	
	.long _sendCommand	
	.dbline -2
L49:
	@FPOP	
	.long R15,R7,R6,R5,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym l arcmode 12 I
	.dbsym l steps 8 I
	.dbsym l anglestep 4 I
	.dbsym l angle 0 I
	.dbsym r yr 4 i
	.dbsym r xr 5 i
	.dbsym r y 6 i
	.dbsym r x 7 i
	.dbend
	.dbfunc e Graph_vec _Graph_vec fV
;     vecdef_ptr -> HRSP+0
;       vecangle -> R4
;       vecscale -> R5
;              y -> R6
;              x -> R7
_Graph_vec::
	@FENTER	
	.long R4,R5,R6,R7,R15,0	
	mov R7,R0	
	mov R6,R1	
	mov R5,R2	
	mov R4,R3	
	.dbline -1
	.dbline 243
; }
; 
; /**
;  * draw a vector
;  * see header for API description.
;  */
; void Graph_vec(gr_uint32_t x, gr_uint32_t y, int vecscale, int vecangle, gr_uint16_t* vecdef_ptr)
; {
	.dbline 244
;     pa[0] = x;
	@FSTOREL	
	.long _pa	
	.long R7	
	.dbline 245
;     pa[1] = y;
	@FSTOREL	
	.long _pa+4	
	.long R6	
	.dbline 246
;     pa[2] = vecscale;
	mov R15,R5	
	@FSTOREL	
	.long _pa+8	
	.long R15	
	.dbline 247
;     pa[3] = vecangle;
	mov R15,R4	
	@FSTOREL	
	.long _pa+12	
	.long R15	
	.dbline 248
;     pa[4] = (gr_uint32_t)vecdef_ptr;
	mov TEMP0,HRSP	
	add TEMP0,#0	
	rdlong TEMP0,TEMP0	
	mov R15,TEMP0	
	@FSTOREL	
	.long _pa+16	
	.long R15	
	.dbline 249
;     sendCommand(GraphCmd_vec, pa);
	mov R0,#7	
	@FLDCNST	
	.long _pa	
	mov R1,TEMP0	
	@FCALL	
	.long _sendCommand	
	.dbline -2
L57:
	@FPOP	
	.long R15,R7,R6,R5,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym l vecdef_ptr 0 ps
	.dbsym r vecangle 4 I
	.dbsym r vecscale 5 I
	.dbsym r y 6 i
	.dbsym r x 7 i
	.dbend
	.dbfunc e Graph_vecarc _Graph_vecarc fV
;     vecdef_ptr -> HRSP+12
;       vecangle -> HRSP+8
;       vecscale -> HRSP+4
;          angle -> HRSP+0
;             yr -> R4
;             xr -> R5
;              y -> R6
;              x -> R7
_Graph_vecarc::
	@FENTER	
	.long R4,R5,R6,R7,R15,0	
	mov R7,R0	
	mov R6,R1	
	mov R5,R2	
	mov R4,R3	
	.dbline -1
	.dbline 257
; }
; 
; /**
;  * draw a vector arc
;  * see header for API description.
;  */
; void Graph_vecarc(gr_uint32_t x, gr_uint32_t y, gr_uint32_t xr, gr_uint32_t yr, int angle, int vecscale, int vecangle, gr_uint16_t* vecdef_ptr)
; {
	.dbline 258
;     pa[0] = x;
	@FSTOREL	
	.long _pa	
	.long R7	
	.dbline 259
;     pa[1] = y;
	@FSTOREL	
	.long _pa+4	
	.long R6	
	.dbline 260
;     pa[2] = xr;
	@FSTOREL	
	.long _pa+8	
	.long R5	
	.dbline 261
;     pa[3] = yr;
	@FSTOREL	
	.long _pa+12	
	.long R4	
	.dbline 262
;     pa[4] = angle;
	mov TEMP0,HRSP	
	add TEMP0,#0	
	rdlong TEMP0,TEMP0	
	mov R15,TEMP0	
	@FSTOREL	
	.long _pa+16	
	.long R15	
	.dbline 263
;     pa[5] = vecscale;
	mov TEMP0,HRSP	
	add TEMP0,#4	
	rdlong TEMP0,TEMP0	
	mov R15,TEMP0	
	@FSTOREL	
	.long _pa+20	
	.long R15	
	.dbline 264
;     pa[6] = vecangle;
	mov TEMP0,HRSP	
	add TEMP0,#8	
	rdlong TEMP0,TEMP0	
	mov R15,TEMP0	
	@FSTOREL	
	.long _pa+24	
	.long R15	
	.dbline 265
;     pa[7] = (gr_uint32_t)vecdef_ptr;
	mov TEMP0,HRSP	
	add TEMP0,#12	
	rdlong TEMP0,TEMP0	
	mov R15,TEMP0	
	@FSTOREL	
	.long _pa+28	
	.long R15	
	.dbline 266
;     sendCommand(GraphCmd_vecarc, pa);
	mov R0,#8	
	@FLDCNST	
	.long _pa	
	mov R1,TEMP0	
	@FCALL	
	.long _sendCommand	
	.dbline -2
L62:
	@FPOP	
	.long R15,R7,R6,R5,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym l vecdef_ptr 12 ps
	.dbsym l vecangle 8 I
	.dbsym l vecscale 4 I
	.dbsym l angle 0 I
	.dbsym r yr 4 i
	.dbsym r xr 5 i
	.dbsym r y 6 i
	.dbsym r x 7 i
	.dbend
	.dbfunc e Graph_pix _Graph_pix fV
;     pixdef_ptr -> R4
;         pixrot -> R5
;              y -> R6
;              x -> R7
_Graph_pix::
	@FENTER	
	.long R4,R5,R6,R7,R15,0	
	mov R7,R0	
	mov R6,R1	
	mov R5,R2	
	mov R4,R3	
	.dbline -1
	.dbline 274
; }
; 
; /**
;  * draw a pixel sprite
;  * see header for API description.
;  */
; void Graph_pix(gr_uint32_t x, gr_uint32_t y, int pixrot, gr_uint16_t* pixdef_ptr)
; {
	.dbline 275
;     pa[0] = x;
	@FSTOREL	
	.long _pa	
	.long R7	
	.dbline 276
;     pa[1] = y;
	@FSTOREL	
	.long _pa+4	
	.long R6	
	.dbline 277
;     pa[2] = pixrot;
	mov R15,R5	
	@FSTOREL	
	.long _pa+8	
	.long R15	
	.dbline 278
;     pa[3] = (long)pixdef_ptr;
	mov R15,R4	
	@FSTOREL	
	.long _pa+12	
	.long R15	
	.dbline 279
;     sendCommand(GraphCmd_pix, pa);
	mov R0,#9	
	@FLDCNST	
	.long _pa	
	mov R1,TEMP0	
	@FCALL	
	.long _sendCommand	
	.dbline -2
L70:
	@FPOP	
	.long R15,R7,R6,R5,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r pixdef_ptr 4 ps
	.dbsym r pixrot 5 I
	.dbsym r y 6 i
	.dbsym r x 7 i
	.dbend
	.dbfunc e Graph_pixarc _Graph_pixarc fV
;     pixdef_ptr -> HRSP+8
;         pixrot -> HRSP+4
;          angle -> HRSP+0
;             yr -> R4
;             xr -> R5
;              y -> R6
;              x -> R7
_Graph_pixarc::
	@FENTER	
	.long R4,R5,R6,R7,R15,0	
	mov R7,R0	
	mov R6,R1	
	mov R5,R2	
	mov R4,R3	
	.dbline -1
	.dbline 287
; }
; 
; /**
;  * draw a pixel sprite at an arc position
;  * see header for API description.
;  */
; void Graph_pixarc(gr_uint32_t x, gr_uint32_t y, gr_uint32_t xr, gr_uint32_t yr, int angle, int pixrot, gr_uint16_t* pixdef_ptr)
; {
	.dbline 288
;     pa[0] = x;
	@FSTOREL	
	.long _pa	
	.long R7	
	.dbline 289
;     pa[1] = y;
	@FSTOREL	
	.long _pa+4	
	.long R6	
	.dbline 290
;     pa[2] = xr;
	@FSTOREL	
	.long _pa+8	
	.long R5	
	.dbline 291
;     pa[3] = yr;
	@FSTOREL	
	.long _pa+12	
	.long R4	
	.dbline 292
;     pa[4] = angle;
	mov TEMP0,HRSP	
	add TEMP0,#0	
	rdlong TEMP0,TEMP0	
	mov R15,TEMP0	
	@FSTOREL	
	.long _pa+16	
	.long R15	
	.dbline 293
;     pa[5] = pixrot;
	mov TEMP0,HRSP	
	add TEMP0,#4	
	rdlong TEMP0,TEMP0	
	mov R15,TEMP0	
	@FSTOREL	
	.long _pa+20	
	.long R15	
	.dbline 294
;     pa[6] = (gr_uint32_t)pixdef_ptr;
	mov TEMP0,HRSP	
	add TEMP0,#8	
	rdlong TEMP0,TEMP0	
	mov R15,TEMP0	
	@FSTOREL	
	.long _pa+24	
	.long R15	
	.dbline 295
;     sendCommand(GraphCmd_pixarc, pa);
	mov R0,#10	
	@FLDCNST	
	.long _pa	
	mov R1,TEMP0	
	@FCALL	
	.long _sendCommand	
	.dbline -2
L74:
	@FPOP	
	.long R15,R7,R6,R5,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym l pixdef_ptr 8 ps
	.dbsym l pixrot 4 I
	.dbsym l angle 0 I
	.dbsym r yr 4 i
	.dbsym r xr 5 i
	.dbsym r y 6 i
	.dbsym r x 7 i
	.dbend
	.area lit(rom,rel)
L82:
	.byte 0,0
	.area text(rom,rel)
	.dbfile C:\DOCUME~1\Steve\MYDOCU~1\_Propeller_OBEX_\Graphics\Graphics.c
	.dbfunc e Graph_char _Graph_char fV
;           just -> HRSP+0
;              s -> HRSP+8
;             ch -> R6
;              y -> R4
;              x -> R5
_Graph_char::
	@FENTER	
	.long R4,R5,R6,R14,R15,0	
	sub HRSP,#12	
	mov R5,R0	
	mov R4,R1	
	mov R6,R2	
	.dbline -1
	.dbline 303
; }
; 
; /**
;  * draw char at x,y
;  * see header for API description.
;  */
; void Graph_char(gr_uint32_t x, gr_uint32_t y, char ch)
; {
	.dbline 306
;     gr_uint32_t just[2];
; 
;     char s[2] = { '\0', '\0' };
	@FLDCNST	
	.long L82	
	mov R15,TEMP0	
	mov R14,HRSP	
	add R14,#8
	mov R1,R15	
	mov R0,R14	
	mov R2,#2	
	@FCALL		
	.long _memcpy		
	.dbline 307
;     s[0] = ch;
	mov R15,HRSP	
	add R15,#8
	wrbyte R6,R15	
	.dbline 308
;     Graph_text(x, y, s);
	mov R0,R5	
	mov R1,R4	
	mov R2,HRSP	
	add R2,#8
	@FCALL	
	.long _Graph_text	
	.dbline -2
L81:
	add HRSP,#12	
	@FPOP	
	.long R15,R14,R6,R5,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym l just 0 A[8:2]i
	.dbsym l s 8 A[2:2]c
	.dbsym r ch 6 c
	.dbsym r y 4 i
	.dbsym r x 5 i
	.dbend
	.dbfunc e Graph_text _Graph_text fV
;           just -> HRSP+0
;     string_ptr -> R4
;              y -> R5
;              x -> R6
_Graph_text::
	@FENTER	
	.long R4,R5,R6,R15,0	
	sub HRSP,#8	
	mov R6,R0	
	mov R5,R1	
	mov R4,R2	
	.dbline -1
	.dbline 316
; }
; 
; /**
;  * draw text at x,y
;  * see header for API description.
;  */
; void Graph_text(gr_uint32_t x, gr_uint32_t y, char* string_ptr)
; {
	.dbline 319
;     gr_uint32_t just[2];
; 
;     justify(string_ptr, just);
	mov R0,R4	
	mov R1,HRSP	
	@FCALL	
	.long _justify	
	.dbline 320
;     pa[0] = x;
	@FSTOREL	
	.long _pa	
	.long R6	
	.dbline 321
;     pa[1] = y;
	@FSTOREL	
	.long _pa+4	
	.long R5	
	.dbline 322
;     pa[2] = (gr_uint32_t)string_ptr;
	mov R15,R4	
	@FSTOREL	
	.long _pa+8	
	.long R15	
	.dbline 323
;     pa[3] = just[0];
	mov R15,HRSP	
	rdlong R15,R15	
	@FSTOREL	
	.long _pa+12	
	.long R15	
	.dbline 324
;     pa[4] = just[1];
	mov R15,HRSP	
	add R15,#4
	rdlong R15,R15	
	@FSTOREL	
	.long _pa+16	
	.long R15	
	.dbline 325
;     sendCommand(GraphCmd_text, pa);
	mov R0,#11	
	@FLDCNST	
	.long _pa	
	mov R1,TEMP0	
	@FCALL	
	.long _sendCommand	
	.dbline -2
L83:
	add HRSP,#8	
	@FPOP	
	.long R15,R6,R5,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym l just 0 A[8:2]i
	.dbsym r string_ptr 4 pc
	.dbsym r y 5 i
	.dbsym r x 6 i
	.dbend
	.dbfunc e Graph_textarc _Graph_textarc fV
;           just -> HRSP+0
;     string_ptr -> HRSP+12
;          angle -> HRSP+8
;             yr -> R4
;             xr -> R5
;              y -> R6
;              x -> R7
_Graph_textarc::
	@FENTER	
	.long R4,R5,R6,R7,R15,0	
	sub HRSP,#8	
	mov R7,R0	
	mov R6,R1	
	mov R5,R2	
	mov R4,R3	
	.dbline -1
	.dbline 333
; }
; 
; /**
;  * draw text at an arc position
;  * see header for API description.
;  */
; void Graph_textarc(gr_uint32_t x, gr_uint32_t y, gr_uint32_t xr, gr_uint32_t yr, int angle, char* string_ptr)
; {
	.dbline 336
;     gr_uint32_t just[2];
; 
;     justify(string_ptr, just);
	mov TEMP0,HRSP	
	add TEMP0,#12	
	rdlong TEMP0,TEMP0	
	mov R0,TEMP0	
	mov R1,HRSP	
	@FCALL	
	.long _justify	
	.dbline 337
;     pa[0] = x;
	@FSTOREL	
	.long _pa	
	.long R7	
	.dbline 338
;     pa[1] = y;
	@FSTOREL	
	.long _pa+4	
	.long R6	
	.dbline 339
;     pa[2] = xr;
	@FSTOREL	
	.long _pa+8	
	.long R5	
	.dbline 340
;     pa[3] = yr;
	@FSTOREL	
	.long _pa+12	
	.long R4	
	.dbline 341
;     pa[4] = angle;
	mov TEMP0,HRSP	
	add TEMP0,#8	
	rdlong TEMP0,TEMP0	
	mov R15,TEMP0	
	@FSTOREL	
	.long _pa+16	
	.long R15	
	.dbline 342
;     pa[5] = (gr_uint32_t)string_ptr;
	mov TEMP0,HRSP	
	add TEMP0,#12	
	rdlong TEMP0,TEMP0	
	mov R15,TEMP0	
	@FSTOREL	
	.long _pa+20	
	.long R15	
	.dbline 343
;     pa[6] = just[0];
	mov R15,HRSP	
	rdlong R15,R15	
	@FSTOREL	
	.long _pa+24	
	.long R15	
	.dbline 344
;     pa[7] = just[1];
	mov R15,HRSP	
	add R15,#4
	rdlong R15,R15	
	@FSTOREL	
	.long _pa+28	
	.long R15	
	.dbline 345
;     sendCommand(GraphCmd_textarc, pa);
	mov R0,#12	
	@FLDCNST	
	.long _pa	
	mov R1,TEMP0	
	@FCALL	
	.long _sendCommand	
	.dbline -2
L89:
	add HRSP,#8	
	@FPOP	
	.long R15,R7,R6,R5,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym l just 0 A[8:2]i
	.dbsym l string_ptr 12 pc
	.dbsym l angle 8 I
	.dbsym r yr 4 i
	.dbsym r xr 5 i
	.dbsym r y 6 i
	.dbsym r x 7 i
	.dbend
	.dbfunc e Graph_textmode _Graph_textmode fV
;             gp -> R5
;  justification -> R4
;        spacing -> R6
;        y_scale -> R7
;        x_scale -> R8
_Graph_textmode::
	@FENTER	
	.long R4,R5,R6,R7,R8,R15,0	
	mov R8,R0	
	mov R7,R1	
	mov R6,R2	
	mov R4,R3	
	.dbline -1
	.dbline 353
; }
; 
; /**
;  * set text size and justification
;  * see header for API description.
;  */
; void Graph_textmode(gr_uint32_t x_scale, gr_uint32_t y_scale, gr_uint32_t spacing, gr_uint32_t justification)
; {
	.dbline 354
;     GraphCmd_ST* gp = &gGraph;
	@FLDCNST	
	.long _gGraph	
	mov R5,TEMP0	
	.dbline 355
;     pa[0] = gp->text_xs = x_scale;
	mov R15,TEMP0	
	add R15,#116	
	wrlong R8,R15	
	@FSTOREL	
	.long _pa	
	.long R8	
	.dbline 356
;     pa[1] = gp->text_ys = y_scale;
	mov R15,R5	
	add R15,#120	
	wrlong R7,R15	
	@FSTOREL	
	.long _pa+4	
	.long R7	
	.dbline 357
;     pa[2] = gp->text_sp = spacing;
	mov R15,R5	
	add R15,#124	
	wrlong R6,R15	
	@FSTOREL	
	.long _pa+8	
	.long R6	
	.dbline 358
;     pa[3] = gp->text_just = justification;
	mov R15,R5	
	add R15,#128	
	wrlong R4,R15	
	@FSTOREL	
	.long _pa+12	
	.long R4	
	.dbline 359
;     sendCommand(GraphCmd_textmode, pa);
	mov R0,#13	
	@FLDCNST	
	.long _pa	
	mov R1,TEMP0	
	@FCALL	
	.long _sendCommand	
	.dbline -2
L98:
	@FPOP	
	.long R15,R8,R7,R6,R5,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r gp 5 pS[GraphCmd_struct]
	.dbsym r justification 4 i
	.dbsym r spacing 6 i
	.dbsym r y_scale 7 i
	.dbsym r x_scale 8 i
	.dbend
	.dbfunc e Graph_box _Graph_box fV
;           pmax -> R8
;           pmin -> R9
;             y2 -> R4
;             x2 -> R7
;          width -> R6
;     box_height -> R4
;      box_width -> R7
;              y -> R5
;              x -> HRSP+12
_Graph_box::
	@FENTER	
	.long R4,R5,R6,R7,R8,R9,R14,R15,0	
	sub HRSP,#16	
	mov TEMP0,HRSP	
	add TEMP0,#12	
	wrlong R0,TEMP0	
	mov R5,R1	
	mov R7,R2	
	mov R4,R3	
	.dbline -1
	.dbline 367
; }
; 
; /**
;  * draw a box with round/square corners according to pixel width
;  * see header for API description.
;  */
; void Graph_box(int x, int y, int box_width, int box_height)
; {
	.dbline 369
;     gr_uint32_t x2, y2, pmin, pmax;
;     int width = gGraph.pixel_width;
	@FLOADL	
	.long _gGraph+8	
	.long R15	
	mov R6,R15	
	.dbline 371
; 
;     if((box_width > width) && (box_height > width))
	cmps R7,R15	WZ WC
IF_BE	rdlong PC,PC	
	.long L104	
	cmps R4,R6	WZ WC
IF_BE	rdlong PC,PC	
	.long L104	
	.dbline 372
;     {
	.dbline 373
;         pmin = width >> 1;
	mov R15,R6	
	sar R15,#1	
	mov R9,R15	
	.dbline 374
;         pmax = width - pmin;
	mov R8,R6	
	sub R8,R9	
	.dbline 375
;         x += pmin;
	mov TEMP0,HRSP	
	add TEMP0,#12	
	rdlong TEMP0,TEMP0	
	mov R15,TEMP0	
	add R15,R9	
	mov TEMP1,R15	
	mov TEMP0,HRSP	
	add TEMP0,#12	
	wrlong TEMP1,TEMP0	
	.dbline 376
;         y += pmin;
	mov R15,R5	
	add R15,R9	
	mov R5,R15	
	.dbline 377
;         x2 = x + box_width  - 1 - width;
	mov TEMP0,HRSP	
	add TEMP0,#12	
	rdlong TEMP0,TEMP0	
	mov R15,TEMP0	
	add R15,R7	
	sub R15,#1	
	sub R15,R6	
	mov R7,R15	
	.dbline 378
;         y2 = y + box_height - 1 - width;
	mov R15,R5	
	add R15,R4	
	sub R15,#1	
	sub R15,R6	
	mov R4,R15	
	.dbline 380
; 
;         Graph_plot(x,y);
	mov TEMP0,HRSP	
	add TEMP0,#12	
	rdlong TEMP0,TEMP0	
	mov R0,TEMP0	
	mov R1,R5	
	@FCALL	
	.long _Graph_plot	
	.dbline 381
;         Graph_plot(x,y2);
	mov TEMP0,HRSP	
	add TEMP0,#12	
	rdlong TEMP0,TEMP0	
	mov R0,TEMP0	
	mov R1,R4	
	@FCALL	
	.long _Graph_plot	
	.dbline 382
;         Graph_plot(x2,y);
	mov R0,R7	
	mov R1,R5	
	@FCALL	
	.long _Graph_plot	
	.dbline 383
;         Graph_plot(x2,y2);
	mov R0,R7	
	mov R1,R4	
	@FCALL	
	.long _Graph_plot	
	.dbline 385
; 
;         fill(x, y2 + pmax, 0, (x2 - x) << 16, 0, 0, pmax);  // fill gaps
	mov TEMP0,HRSP	
	add TEMP0,#12	
	rdlong TEMP0,TEMP0	
	mov R0,TEMP0	
	mov R15,R4	
	add R15,R8	
	mov R1,R15	
	mov R2,#0	
	mov TEMP0,HRSP	
	add TEMP0,#12	
	rdlong TEMP0,TEMP0	
	mov R15,TEMP0	
	mov R14,R7	
	sub R14,R15	
	mov R15,R14	
	shl R15,#16	
	mov R3,R15	
	mov R15,#0	
	mov TEMP5,HRSP	
	wrlong R15,HRSP	
	mov R15,#0	
	mov TEMP5,HRSP	
	add TEMP5,#4	
	wrlong R15,TEMP5	
	mov R15,R8	
	mov TEMP5,HRSP	
	add TEMP5,#8	
	wrlong R15,TEMP5	
	@FCALL	
	.long _fill	
	.dbline 386
;         fill(x, y, 0, (x2 - x) << 16, 0, 0, pmin);
	mov TEMP0,HRSP	
	add TEMP0,#12	
	rdlong TEMP0,TEMP0	
	mov R0,TEMP0	
	mov R1,R5	
	mov R2,#0	
	mov TEMP0,HRSP	
	add TEMP0,#12	
	rdlong TEMP0,TEMP0	
	mov R15,TEMP0	
	mov R14,R7	
	sub R14,R15	
	mov R15,R14	
	shl R15,#16	
	mov R3,R15	
	mov R15,#0	
	mov TEMP5,HRSP	
	wrlong R15,HRSP	
	mov R15,#0	
	mov TEMP5,HRSP	
	add TEMP5,#4	
	wrlong R15,TEMP5	
	mov R15,R9	
	mov TEMP5,HRSP	
	add TEMP5,#8	
	wrlong R15,TEMP5	
	@FCALL	
	.long _fill	
	.dbline 387
;         fill(x - pmin, y2, 0, (x2 - x + width) << 16, 0, 0, y2 - y);
	mov TEMP0,HRSP	
	add TEMP0,#12	
	rdlong TEMP0,TEMP0	
	mov R15,TEMP0	
	sub R15,R9	
	mov R0,R15	
	mov R1,R4	
	mov R2,#0	
	mov TEMP0,HRSP	
	add TEMP0,#12	
	rdlong TEMP0,TEMP0	
	mov R15,TEMP0	
	mov R14,R7	
	sub R14,R15	
	add R14,R6	
	mov R15,R14	
	shl R15,#16	
	mov R3,R15	
	mov R15,#0	
	mov TEMP5,HRSP	
	wrlong R15,HRSP	
	mov R15,#0	
	mov TEMP5,HRSP	
	add TEMP5,#4	
	wrlong R15,TEMP5	
	mov R15,R5	
	mov R14,R4	
	sub R14,R15	
	mov R15,R14	
	mov TEMP5,HRSP	
	add TEMP5,#8	
	wrlong R15,TEMP5	
	@FCALL	
	.long _fill	
	.dbline 388
;     }
L104:
	.dbline -2
L102:
	add HRSP,#16	
	@FPOP	
	.long R15,R14,R9,R8,R7,R6,R5,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r pmax 8 i
	.dbsym r pmin 9 i
	.dbsym r y2 4 i
	.dbsym r x2 7 i
	.dbsym r width 6 I
	.dbsym r box_height 4 I
	.dbsym r box_width 7 I
	.dbsym r y 5 I
	.dbsym l x 12 I
	.dbend
	.dbfunc e Graph_quad _Graph_quad fV
;             y4 -> HRSP+20
;             x4 -> HRSP+16
;             y3 -> HRSP+12
;             x3 -> HRSP+8
;             y2 -> R6
;             x2 -> R7
;             y1 -> R4
;             x1 -> R5
_Graph_quad::
	@FENTER	
	.long R4,R5,R6,R7,0	
	sub HRSP,#8	
	mov R5,R0	
	mov R4,R1	
	mov R7,R2	
	mov R6,R3	
	.dbline -1
	.dbline 396
; }
; 
; /**
;  * draw a solid quadrilateral
;  * see header for API description.
;  */
; void Graph_quad(gr_uint32_t x1, gr_uint32_t y1, gr_uint32_t x2, gr_uint32_t y2, gr_uint32_t x3, gr_uint32_t y3, gr_uint32_t x4, gr_uint32_t y4)
; {
	.dbline 397
;     Graph_tri(x1, y1, x2, y2, x3, y3);
	mov R0,R5	
	mov R1,R4	
	mov R2,R7	
	mov R3,R6	
	mov TEMP5,HRSP	
	mov TEMP1,HRSP	
	add TEMP1,#8	
	rdlong TEMP1,TEMP1	
	wrlong TEMP1,TEMP5	
	mov TEMP5,HRSP	
	add TEMP5,#4	
	mov TEMP1,HRSP	
	add TEMP1,#12	
	rdlong TEMP1,TEMP1	
	wrlong TEMP1,TEMP5	
	@FCALL	
	.long _Graph_tri	
	.dbline 398
;     Graph_tri(x3, y3, x4, y4, x1, y1);
	mov TEMP0,HRSP	
	add TEMP0,#8	
	rdlong TEMP0,TEMP0	
	mov R0,TEMP0	
	mov TEMP0,HRSP	
	add TEMP0,#12	
	rdlong TEMP0,TEMP0	
	mov R1,TEMP0	
	mov TEMP0,HRSP	
	add TEMP0,#16	
	rdlong TEMP0,TEMP0	
	mov R2,TEMP0	
	mov TEMP0,HRSP	
	add TEMP0,#20	
	rdlong TEMP0,TEMP0	
	mov R3,TEMP0	
	mov TEMP5,HRSP	
	wrlong R5,HRSP	
	mov TEMP5,HRSP	
	add TEMP5,#4	
	wrlong R4,TEMP5	
	@FCALL	
	.long _Graph_tri	
	.dbline -2
L106:
	add HRSP,#8	
	@FPOP	
	.long R7,R6,R5,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym l y4 20 i
	.dbsym l x4 16 i
	.dbsym l y3 12 i
	.dbsym l x3 8 i
	.dbsym r y2 6 i
	.dbsym r x2 7 i
	.dbsym r y1 4 i
	.dbsym r x1 5 i
	.dbend
	.dbfunc e Graph_tri _Graph_tri fV
;             xy -> HRSP+24
;         mycase -> R5
;             y3 -> R8
;             x3 -> R7
;             y2 -> R9
;             x2 -> HRSP+12
;             y1 -> HRSP+16
;             x1 -> HRSP+20
_Graph_tri::
	@FENTER	
	.long R4,R5,R6,R7,R8,R9,R11,R12,R13,R14,R15,0	
	sub HRSP,#32	
	mov TEMP0,HRSP	
	add TEMP0,#20	
	wrlong R0,TEMP0	
	mov TEMP0,HRSP	
	add TEMP0,#16	
	wrlong R1,TEMP0	
	mov TEMP0,HRSP	
	add TEMP0,#12	
	wrlong R2,TEMP0	
	mov R9,R3	
	mov TEMP0,HRSP	
	add TEMP0,#32	
	rdlong R7,TEMP0	
	mov TEMP0,HRSP	
	add TEMP0,#36	
	rdlong R8,TEMP0	
	.dbline -1
	.dbline 402
; }
; 
; void Graph_tri(gr_uint32_t x1, gr_uint32_t y1, gr_uint32_t x2, gr_uint32_t y2, gr_uint32_t x3, gr_uint32_t y3)
; {
	.dbline 404
;     int xy[2];
;     int mycase = ((y1 >= y2) ? 4 : 0) | ((y2 >= y3) ? 2 : 0) | ((y1 >= y3) ? 1 : 0);
	mov TEMP1,HRSP	
	add TEMP1,#16	
	rdlong TEMP1,TEMP1	
	cmp TEMP1,R9	WC
IF_B	add PC,#8	;Jump to L111
	mov R6,#4	
	add PC,#4	;Jump to L112
L111:
	mov R6,#0	
L112:
	cmp R9,R8	WC
IF_B	add PC,#8	;Jump to L113
	mov R5,#2	
	add PC,#4	;Jump to L114
L113:
	mov R5,#0	
L114:
	mov TEMP1,HRSP	
	add TEMP1,#16	
	rdlong TEMP1,TEMP1	
	cmp TEMP1,R8	WC
IF_B	add PC,#8	;Jump to L115
	mov R4,#1	
	add PC,#4	;Jump to L116
L115:
	mov R4,#0	
L116:
	mov R15,R6	
	or R15,R5	
	mov R5,R15	
	or R5,R4	WZ
	.dbline 406
; 
;     switch(mycase) {
IF_E	add PC,#52	;Jump to L119
	cmp R5,#2	WZ
IF_E	add PC,#164	;Jump to L122
	cmp R5,#3	WZ
IF_E	rdlong PC,PC	
	.long L125	
	cmp R5,#4	WZ
IF_E	rdlong PC,PC	
	.long L128	
	cmp R5,#5	WZ
IF_E	rdlong PC,PC	
	.long L131	
	rdlong PC,PC	
	.long L118	
L119:
	.dbline 408
;         case 0:
;             xy[0] = x1; 
	mov TEMP0,HRSP	
	add TEMP0,#20	
	rdlong TEMP0,TEMP0	
	mov R15,TEMP0	
	mov R14,HRSP	
	add R14,#24
	wrlong R15,R14	
	.dbline 409
;             xy[1] = y1; // 2 longs 
	mov TEMP0,HRSP	
	add TEMP0,#16	
	rdlong TEMP0,TEMP0	
	mov R15,TEMP0	
	mov R14,HRSP	
	add R14,#28
	wrlong R15,R14	
	.dbline 410
;             x1 = x3;
	mov TEMP1,R7	
	mov TEMP0,HRSP	
	add TEMP0,#20	
	wrlong TEMP1,TEMP0	
	.dbline 411
;             y1 = y3;    // 2 longs
	mov TEMP1,R8	
	mov TEMP0,HRSP	
	add TEMP0,#16	
	wrlong TEMP1,TEMP0	
	.dbline 412
;             x3 = xy[0];
	mov R15,HRSP	
	add R15,#24
	rdlong R7,R15	
	.dbline 413
;             y3 = xy[1]; // 2 longs
	mov R15,HRSP	
	add R15,#28
	rdlong R8,R15	
	.dbline 414
;             break;
	rdlong PC,PC	
	.long L118	
L122:
	.dbline 416
;         case 2:
;             xy[0] = x1; 
	mov TEMP0,HRSP	
	add TEMP0,#20	
	rdlong TEMP0,TEMP0	
	mov R15,TEMP0	
	mov R14,HRSP	
	add R14,#24
	wrlong R15,R14	
	.dbline 417
;             xy[1] = y1; // 2 longs
	mov TEMP0,HRSP	
	add TEMP0,#16	
	rdlong TEMP0,TEMP0	
	mov R15,TEMP0	
	mov R14,HRSP	
	add R14,#28
	wrlong R15,R14	
	.dbline 418
;             x1 = x2;
	mov TEMP0,HRSP	
	add TEMP0,#12	
	rdlong TEMP0,TEMP0	
	mov TEMP1,TEMP0	
	mov TEMP0,HRSP	
	add TEMP0,#20	
	wrlong TEMP1,TEMP0	
	.dbline 419
;             y1 = y2;
	mov TEMP1,R9	
	mov TEMP0,HRSP	
	add TEMP0,#16	
	wrlong TEMP1,TEMP0	
	.dbline 420
;             x2 = x3;
	mov TEMP1,R7	
	mov TEMP0,HRSP	
	add TEMP0,#12	
	wrlong TEMP1,TEMP0	
	.dbline 421
;             y2 = y3;    // 4 longs
	mov R9,R8	
	.dbline 422
;             x3 = xy[0];
	mov R15,HRSP	
	add R15,#24
	rdlong R7,R15	
	.dbline 423
;             y3 = xy[1]; // 2 longs
	mov R15,HRSP	
	add R15,#28
	rdlong R8,R15	
	.dbline 424
;             break;
	rdlong PC,PC	
	.long L118	
L125:
	.dbline 426
;         case 3:
;             xy[0] = x1; 
	mov TEMP0,HRSP	
	add TEMP0,#20	
	rdlong TEMP0,TEMP0	
	mov R15,TEMP0	
	mov R14,HRSP	
	add R14,#24
	wrlong R15,R14	
	.dbline 427
;             xy[1] = y1; // 2 longs
	mov TEMP0,HRSP	
	add TEMP0,#16	
	rdlong TEMP0,TEMP0	
	mov R15,TEMP0	
	mov R14,HRSP	
	add R14,#28
	wrlong R15,R14	
	.dbline 428
;             x1 = x2;
	mov TEMP0,HRSP	
	add TEMP0,#12	
	rdlong TEMP0,TEMP0	
	mov TEMP1,TEMP0	
	mov TEMP0,HRSP	
	add TEMP0,#20	
	wrlong TEMP1,TEMP0	
	.dbline 429
;             y1 = y2;    // 2 longs
	mov TEMP1,R9	
	mov TEMP0,HRSP	
	add TEMP0,#16	
	wrlong TEMP1,TEMP0	
	.dbline 430
;             x2 = xy[0];
	mov R15,HRSP	
	add R15,#24
	rdlong TEMP1,R15	
	mov TEMP0,HRSP	
	add TEMP0,#12	
	wrlong TEMP1,TEMP0	
	.dbline 431
;             y2 = xy[1]; // 2 longs
	mov R15,HRSP	
	add R15,#28
	rdlong R9,R15	
	.dbline 432
;             break;
	add PC,#236	;Jump to L118
L128:
	.dbline 434
;         case 4:
;             xy[0] = x3; 
	mov R15,R7	
	mov R14,HRSP	
	add R14,#24
	wrlong R15,R14	
	.dbline 435
;             xy[1] = y3; // 2 longs
	mov R15,R8	
	mov R14,HRSP	
	add R14,#28
	wrlong R15,R14	
	.dbline 436
;             x2 = x1;
	mov TEMP0,HRSP	
	add TEMP0,#20	
	rdlong TEMP0,TEMP0	
	mov TEMP1,TEMP0	
	mov TEMP0,HRSP	
	add TEMP0,#12	
	wrlong TEMP1,TEMP0	
	.dbline 437
;             y2 = y1;
	mov TEMP0,HRSP	
	add TEMP0,#16	
	rdlong TEMP0,TEMP0	
	mov R9,TEMP0	
	.dbline 438
;             x3 = x2;
	mov TEMP0,HRSP	
	add TEMP0,#12	
	rdlong TEMP0,TEMP0	
	mov R7,TEMP0	
	.dbline 439
;             y3 = y2;    // 4 longs
	mov R8,R9	
	.dbline 440
;             x1 = xy[0];
	mov R15,HRSP	
	add R15,#24
	rdlong TEMP1,R15	
	mov TEMP0,HRSP	
	add TEMP0,#20	
	wrlong TEMP1,TEMP0	
	.dbline 441
;             y1 = xy[1]; // 2 longs
	mov R15,HRSP	
	add R15,#28
	rdlong TEMP1,R15	
	mov TEMP0,HRSP	
	add TEMP0,#16	
	wrlong TEMP1,TEMP0	
	.dbline 442
;             break;
	add PC,#88	;Jump to L118
L131:
	.dbline 444
;         case 5:
;             xy[0] = x2; 
	mov TEMP0,HRSP	
	add TEMP0,#12	
	rdlong TEMP0,TEMP0	
	mov R15,TEMP0	
	mov R14,HRSP	
	add R14,#24
	wrlong R15,R14	
	.dbline 445
;             xy[1] = y2; // 2 longs
	mov R15,R9	
	mov R14,HRSP	
	add R14,#28
	wrlong R15,R14	
	.dbline 446
;             x2 = x3;
	mov TEMP1,R7	
	mov TEMP0,HRSP	
	add TEMP0,#12	
	wrlong TEMP1,TEMP0	
	.dbline 447
;             y2 = y3;    // 2 longs
	mov R9,R8	
	.dbline 448
;             x3 = xy[0];
	mov R15,HRSP	
	add R15,#24
	rdlong R7,R15	
	.dbline 449
;             y3 = xy[1]; // 2 longs
	mov R15,HRSP	
	add R15,#28
	rdlong R8,R15	
	.dbline 450
;             break;
	.dbline 452
;         default:
;             break;
L118:
	.dbline 455
;     }
; 
;     fill(x1, y1, ((x3 - x1) << 16) / (y1 - y3 + 1), ((x2 - x1) << 16) / (y1 - y2 + 1), ((x3 - x2) << 16) / (y2 - y3 + 1), y1 - y2, y1 - y3);
	mov TEMP0,HRSP	
	add TEMP0,#16	
	rdlong TEMP0,TEMP0	
	mov R15,TEMP0	
	sub R15,R8	
	mov R14,R7	
	mov TEMP0,HRSP	
	add TEMP0,#20	
	rdlong TEMP0,TEMP0	
	sub R14,TEMP0	
	mov R0,R14	
	shl R0,#16	
	mov R1,R15	
	add R1,#1	
	@FDIV32U	
	mov R14,R0	
	mov TEMP0,HRSP	
	add TEMP0,#16	
	rdlong TEMP0,TEMP0	
	mov R13,TEMP0	
	sub R13,R9	
	mov TEMP0,HRSP	
	add TEMP0,#12	
	rdlong TEMP0,TEMP0	
	mov R12,TEMP0	
	mov TEMP0,HRSP	
	add TEMP0,#20	
	rdlong TEMP0,TEMP0	
	sub R12,TEMP0	
	mov R0,R12	
	shl R0,#16	
	mov R1,R13	
	add R1,#1	
	@FDIV32U	
	mov R12,R0	
	mov R11,R9	
	sub R11,R8	
	mov R1,R11	
	add R1,#1	
	mov R11,R7	
	mov TEMP0,HRSP	
	add TEMP0,#12	
	rdlong TEMP0,TEMP0	
	sub R11,TEMP0	
	mov R0,R11	
	shl R0,#16	
	@FDIV32U	
	mov R11,R0	
	mov TEMP0,HRSP	
	add TEMP0,#20	
	rdlong TEMP0,TEMP0	
	mov R0,TEMP0	
	mov TEMP0,HRSP	
	add TEMP0,#16	
	rdlong TEMP0,TEMP0	
	mov R1,TEMP0	
	mov R2,R14	
	mov R3,R12	
	mov R14,R11	
	mov TEMP5,HRSP	
	wrlong R14,HRSP	
	mov R14,R13	
	mov TEMP5,HRSP	
	add TEMP5,#4	
	wrlong R14,TEMP5	
	mov R15,R15	
	mov TEMP5,HRSP	
	add TEMP5,#8	
	wrlong R15,TEMP5	
	@FCALL	
	.long _fill	
	.dbline -2
L107:
	add HRSP,#32	
	@FPOP	
	.long R15,R14,R13,R12,R11,R9,R8,R7,R6,R5,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym l xy 24 A[8:2]I
	.dbsym r mycase 5 I
	.dbsym r y3 8 i
	.dbsym r x3 7 i
	.dbsym r y2 9 i
	.dbsym l x2 12 i
	.dbsym l y1 16 i
	.dbsym l x1 20 i
	.dbend
	.dbfunc e Graph_finish _Graph_finish fV
_Graph_finish::
	.dbline -1
	.dbline 462
; }
; 
; /**
;  * make sure last command is done
;  */
; void Graph_finish(void)
; {
	.dbline 463
;     sendCommand(GraphCmd_loop, 0);
	mov R0,#15	
	mov R1,#0	
	@FCALL	
	.long _sendCommand	
	.dbline -2
L134:
	@FRET
	.dbline 0 ; func end
	.dbend
	.dbfunc s fill _fill fV
;  lines_minus_1 -> HRSP+8
;     linechange -> HRSP+4
;            db2 -> HRSP+0
;             db -> R4
;             da -> R5
;              y -> R6
;              x -> R7
_fill:
	@FENTER	
	.long R4,R5,R6,R7,R15,0	
	mov R7,R0	
	mov R6,R1	
	mov R5,R2	
	mov R4,R3	
	.dbline -1
	.dbline 471
; }
; 
; 
; /**
;  * fill blocks
;  */
; static void fill(int x, int y, int da, int db, int db2, int linechange, int lines_minus_1)
; {
	.dbline 472
;     pa[0] = x;
	mov R15,R7	
	@FSTOREL	
	.long _pa	
	.long R15	
	.dbline 473
;     pa[1] = y;
	mov R15,R6	
	@FSTOREL	
	.long _pa+4	
	.long R15	
	.dbline 474
;     pa[2] = da;
	mov R15,R5	
	@FSTOREL	
	.long _pa+8	
	.long R15	
	.dbline 475
;     pa[3] = db;
	mov R15,R4	
	@FSTOREL	
	.long _pa+12	
	.long R15	
	.dbline 476
;     pa[4] = db2;
	mov TEMP0,HRSP	
	add TEMP0,#0	
	rdlong TEMP0,TEMP0	
	mov R15,TEMP0	
	@FSTOREL	
	.long _pa+16	
	.long R15	
	.dbline 477
;     pa[5] = linechange;
	mov TEMP0,HRSP	
	add TEMP0,#4	
	rdlong TEMP0,TEMP0	
	mov R15,TEMP0	
	@FSTOREL	
	.long _pa+20	
	.long R15	
	.dbline 478
;     pa[6] = lines_minus_1;
	mov TEMP0,HRSP	
	add TEMP0,#8	
	rdlong TEMP0,TEMP0	
	mov R15,TEMP0	
	@FSTOREL	
	.long _pa+24	
	.long R15	
	.dbline 479
;     sendCommand(GraphCmd_fill, pa);
	mov R0,#14	
	@FLDCNST	
	.long _pa	
	mov R1,TEMP0	
	@FCALL	
	.long _sendCommand	
	.dbline -2
L135:
	@FPOP	
	.long R15,R7,R6,R5,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym l lines_minus_1 8 I
	.dbsym l linechange 4 I
	.dbsym l db2 0 I
	.dbsym r db 4 I
	.dbsym r da 5 I
	.dbsym r y 6 I
	.dbsym r x 7 I
	.dbend
	.dbfunc s justify _justify fV
;              x -> R6
;            ja2 -> HRSP+0
;            ja1 -> HRSP+16
;             gp -> R5
;        justptr -> R4
;     string_ptr -> R6
_justify:
	@FENTER	
	.long R4,R5,R6,R13,R14,R15,0	
	sub HRSP,#32	
	mov R6,R0	
	mov R4,R1	
	.dbline -1
	.dbline 486
; }
; 
; /**
;  * justify apparently aligns string edges
;  */
; static void justify(char* string_ptr, gr_uint32_t* justptr)
; {
	.dbline 487
;     GraphCmd_ST* gp = &gGraph;
	@FLDCNST	
	.long _gGraph	
	mov R5,TEMP0	
	.dbline 488
;     gr_uint32_t x = (strlen(string_ptr) - 1) * gp->text_xs * gp->text_sp + gp->text_xs * 5 - 1;
	mov R0,R6	
	@FCALL	
	.long _strlen	
	mov R15,R0	
	mov R14,R5	
	add R14,#116	
	rdlong R14,R14	
	mov R15,R15	
	sub R15,#1	
	mov R0,R15	
	mov R1,R14	
	@FMUL32	
	mov R15,R0	
	mov R13,R5	
	add R13,#124	
	rdlong R13,R13	
	mov R0,R15	
	mov R1,R13	
	@FMUL32	
	mov R15,R0	
	mov R0,#5	
	mov R1,R14	
	@FMUL32	
	mov R14,R0	
	mov R15,R15	
	add R15,R14	
	mov R6,R15	
	sub R6,#1	
	.dbline 493
;     gr_uint32_t ja1[4];
;     gr_uint32_t ja2[4];
;     
;     // p1 is an alias of ja1
;     ja1[0] = 0;
	mov R15,#0	
	mov R14,HRSP	
	add R14,#16
	wrlong R15,R14	
	.dbline 494
;     ja1[1] = x >> 1;
	mov R15,R6	
	shr R15,#1	
	mov R14,HRSP	
	add R14,#20
	wrlong R15,R14	
	.dbline 495
;     ja1[2] = x;
	mov R15,HRSP	
	add R15,#24
	wrlong R6,R15	
	.dbline 496
;     ja1[3] = 0;
	mov R15,#0	
	mov R14,HRSP	
	add R14,#28
	wrlong R15,R14	
	.dbline 497
;     justptr[0] = -ja1[gp->text_just]; // -lookupz(text_just >> 2 & 3: 0, x >> 1, x, 0)
	mov R15,R5	
	add R15,#128	
	rdlong R15,R15	
	mov R0,#4	
	mov R1,R15	
	@FMUL32	
	mov R15,R0	
	mov R14,HRSP	
	add R14,#16
	mov R15,R15	
	add R15,R14	
	rdlong R15,R15	
	neg R15,R15	
	sub R15,#1	
	add R15,#1	
	wrlong R15,R4	
	.dbline 500
; 
;     // p2 is an alias of ja1
;     ja2[0] = 0;
	mov R15,#0	
	mov R14,HRSP	
	wrlong R15,R14	
	.dbline 501
;     ja2[1] = gp->text_ys << 3;
	mov R15,R5	
	add R15,#120	
	rdlong R15,R15	
	shl R15,#3	
	mov R14,HRSP	
	add R14,#4
	wrlong R15,R14	
	.dbline 502
;     ja2[2] = gp->text_ys << 4;
	mov R15,R5	
	add R15,#120	
	rdlong R15,R15	
	shl R15,#4	
	mov R14,HRSP	
	add R14,#8
	wrlong R15,R14	
	.dbline 503
;     ja2[3] = 0;
	mov R15,#0	
	mov R14,HRSP	
	add R14,#12
	wrlong R15,R14	
	.dbline 504
;     justptr[1] = -ja2[gp->text_just]; // -lookupz(text_just & 3: 0, text_ys << 3, text_ys << 4, 0)
	mov R15,R5	
	add R15,#128	
	rdlong R15,R15	
	mov R0,#4	
	mov R1,R15	
	@FMUL32	
	mov R15,R0	
	mov R14,HRSP	
	mov R15,R15	
	add R15,R14	
	rdlong R15,R15	
	neg R15,R15	
	sub R15,#1	
	add R15,#1	
	mov R14,R4	
	add R14,#4	
	wrlong R15,R14	
	.dbline -2
L142:
	add HRSP,#32	
	@FPOP	
	.long R15,R14,R13,R6,R5,R4,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r x 6 i
	.dbsym l ja2 0 A[16:4]i
	.dbsym l ja1 16 A[16:4]i
	.dbsym r gp 5 pS[GraphCmd_struct]
	.dbsym r justptr 4 pi
	.dbsym r string_ptr 6 pc
	.dbend
	.dbfunc s sendCommand _sendCommand fV
;         argptr -> R1
;            cmd -> R0
_sendCommand:
	@FENTER	
	.long R14,R15,0	
	.dbline -1
	.dbline 526
; }
; 
; //#include <asio.h>
; #ifdef __ASIO_H__
; char* cmds[] = {
;     "None",  "Setup",
;     "Color", "Width",
;     "Plot",  "Line", 
;     "Arc",   "Vec", "VecArc",
;     "Pix",   "PixArc",
;     "Text",  "TextArc", "TextMode",
;     "Fill",  "Loop",
;     0 };
; #endif
; 
; /**
;  * send command to driver
;  * @param cmd    - GraphCmd_ET command
;  * @param argptr - arguments pointer
;  */
; static void sendCommand(GraphCmd_ET cmd, gr_uint32_t* argptr)
; {
	.dbline 528
;     //write command and pointer
;     gGraph.command = ((cmd << 16) | ((int)argptr & 0xffff));
	@FLDCNST	
	.long 65535	
	mov R15,TEMP0	
	mov R14,R1	
	and R14,R15	
	mov R15,R0	
	and R15,MASKFF	
	shl R15,#16	
	or R15,R14	
	@FSTOREL	
	.long _gGraph+4	
	.long R15	
L151:
	.dbline 535
; #ifdef __ASIO_H__
;     printf("\r\nsendCommand(0x%x, 0x%x): 0x%x ... %s", cmd, (int)argptr, command, cmds[cmd]);
; #endif
; 
;     // wait for command to be cleared, signifying receipt
;     while(gGraph.command != 0)
;         ;
L152:
	.dbline 534
	@FLOADL	
	.long _gGraph+4	
	.long R15	
	cmp R15,#0	WZ
IF_NE	sub PC,#20	;Jump to L151
	.dbline -2
L149:
	@FPOP	
	.long R15,R14,0	
	@FRET
	.dbline 0 ; func end
	.dbsym r argptr 1 pi
	.dbsym r cmd 0 c
	.dbend
	.area bss(ram,rel)
	.dbfile C:\DOCUME~1\Steve\MYDOCU~1\_Propeller_OBEX_\Graphics\Graphics.c
	.align	4
_pa:
	.blkb 36
	.dbsym s pa _pa A[36:9]i
	.align	4
_gGraph:
	.blkb 132
	.dbsym s gGraph _gGraph S[GraphCmd_struct]
